#!/usr/bin/python

import sys
import TorCtl
import socket

kp_host = "localhost"
kp_port = 34553
validcommands = []

def printUsageExit(argzero):
	print('Usage: ' + argzero + " <add|addTor> <bridge ip>:<bridge port> [fingerprint] <bridge key>")
	exit()

def setTorConf(ipport):
	conn = TorCtl.connect()
	conn.set_option("Bridge", ipport)
	conn.set_option("UseBridges", "1")
	conn.save_conf()
	
def setKnockProxyConf(ipport, bridgekey):
	s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	s.connect((kp_host,kp_port))
	s.send(ipport + "|" + bridgekey)
	s.close()
	
def main(argv):
	if len(argv) < 4 or len(argv) > 5:
		printUsageExit(argv[0])
	
	command = argv[1]
	ipport = argv[2]
	fingerprint = ""
	bridgekey = ""
	ip = ""
	port = 0
	
	if len(argv) == 4:
		bridgekey = argv[3]
	elif len(argv) == 5:
		fingerprint = argv[3]
		bridgekey = argv[4]
	
	if command != "add" and command != "addTor":
		printUsageExit(argv[0])
	
	port_separator = ipport.find(':')
	
	if port_separator == -1:
		printUsageExit(argv[0])
	else:
		ip = ipport[0:port_separator]
		port = int(ipport[port_separator+1:])
	
	if ip.count('.') != 3:
		printUsageExit(argv[0])

	setKnockProxyConf(ipport, bridgekey)

	if command == "addTor":
		setTorConf(ipport) #TODO: fingerprint

if __name__ == "__main__":
	main(sys.argv)
